/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.243 Revision 1.363
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.243 2006/07/05 01:16:18 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.363 2011/09/12 20:44:01 mgorny Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# This eclass is for general purpose functions that most ebuilds 15# Due to the nature of this eclass, some functions may have maintainers
6# have to implement themselves. 16# different from the overall eclass!
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 17
12inherit multilib portability 18inherit multilib portability
13 19
14DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
15 21
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
18# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
19# must be an integer greater than zero. 25# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 31epause() {
22 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23 sleep ${1:-5}
24 fi
25} 33}
26 34
27# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
28# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
29# don't beep. 37# @DESCRIPTION:
30# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
31ebeep() { 42ebeep() {
32 local n 43 local n
33 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
34 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
35 echo -ne "\a" 46 echo -ne "\a"
36 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
37 echo -ne "\a" 48 echo -ne "\a"
38 sleep 1 49 sleep 1
39 done 50 done
40 fi 51 fi
41} 52}
42 53
43# This function generate linker scripts in /usr/lib for dynamic 54else
44# libs in /lib. This is to fix linking problems when you have
45# the .so in /lib, and the .a in /usr/lib. What happens is that
46# in some cases when linking dynamic, the .a in /usr/lib is used
47# instead of the .so in /lib due to gcc/libtool tweaking ld's
48# library search path. This cause many builds to fail.
49# See bug #4411 for more info.
50#
51# To use, simply call:
52#
53# gen_usr_ldscript libfoo.so
54#
55# Note that you should in general use the unversioned name of
56# the library, as ldconfig should usually update it correctly
57# to point to the latest version of the library present.
58#
59# <azarah@gentoo.org> (26 Oct 2002)
60#
61gen_usr_ldscript() {
62 local lib libdir=$(get_libdir)
63 # Just make sure it exists
64 dodir /usr/${libdir}
65 55
66 for lib in "${@}" ; do 56ebeep() {
67 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
68 /* GNU ld script 58}
69 Since Gentoo has critical dynamic libraries
70 in /lib, and the static versions in /usr/lib,
71 we need to have a "fake" dynamic lib in /usr/lib,
72 otherwise we run into linking problems.
73 59
74 See bug http://bugs.gentoo.org/4411 for more info. 60epause() {
75 */ 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
76 GROUP ( /${libdir}/${lib} ) 62}
77 END_LDSCRIPT 63
78 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
76fi
77
78# @FUNCTION: ecvs_clean
79# @USAGE: [list of dirs]
80# @DESCRIPTION:
81# Remove CVS directories recursiveley. Useful when a source tarball contains
82# internal CVS directories. Defaults to $PWD.
83ecvs_clean() {
84 [[ -z $* ]] && set -- .
85 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
86 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
87}
88
89# @FUNCTION: esvn_clean
90# @USAGE: [list of dirs]
91# @DESCRIPTION:
92# Remove .svn directories recursiveley. Useful when a source tarball contains
93# internal Subversion directories. Defaults to $PWD.
94esvn_clean() {
95 [[ -z $* ]] && set -- .
96 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
97}
98
99# @FUNCTION: eshopts_push
100# @USAGE: [options to `set` or `shopt`]
101# @DESCRIPTION:
102# Often times code will want to enable a shell option to change code behavior.
103# Since changing shell options can easily break other pieces of code (which
104# assume the default state), eshopts_push is used to (1) push the current shell
105# options onto a stack and (2) pass the specified arguments to set.
106#
107# If the first argument is '-s' or '-u', we assume you want to call `shopt`
108# rather than `set` as there are some options only available via that.
109#
110# A common example is to disable shell globbing so that special meaning/care
111# may be used with variables/arguments to custom functions. That would be:
112# @CODE
113# eshopts_push -o noglob
114# for x in ${foo} ; do
115# if ...some check... ; then
116# eshopts_pop
117# return 0
118# fi
79 done 119# done
120# eshopts_pop
121# @CODE
122eshopts_push() {
123 # have to assume __ESHOPTS_SAVE__ isn't screwed with
124 # as a `declare -a` here will reset its value
125 local i=${#__ESHOPTS_SAVE__[@]}
126 if [[ $1 == -[su] ]] ; then
127 __ESHOPTS_SAVE__[$i]=$(shopt -p)
128 [[ $# -eq 0 ]] && return 0
129 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
130 else
131 __ESHOPTS_SAVE__[$i]=$-
132 [[ $# -eq 0 ]] && return 0
133 set "$@" || die "eshopts_push: bad options to set: $*"
134 fi
80} 135}
81 136
137# @FUNCTION: eshopts_pop
138# @USAGE:
139# @DESCRIPTION:
140# Restore the shell options to the state saved with the corresponding
141# eshopts_push call. See that function for more details.
142eshopts_pop() {
143 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
144 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
145 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
146 local s=${__ESHOPTS_SAVE__[$i]}
147 unset __ESHOPTS_SAVE__[$i]
148 if [[ ${s} == "shopt -"* ]] ; then
149 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
150 else
151 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
152 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
153 fi
154}
82 155
83# Default directory where patches are located 156# @VARIABLE: EPATCH_SOURCE
157# @DESCRIPTION:
158# Default directory to search for patches.
84EPATCH_SOURCE="${WORKDIR}/patch" 159EPATCH_SOURCE="${WORKDIR}/patch"
85# Default extension for patches 160# @VARIABLE: EPATCH_SUFFIX
161# @DESCRIPTION:
162# Default extension for patches (do not prefix the period yourself).
86EPATCH_SUFFIX="patch.bz2" 163EPATCH_SUFFIX="patch.bz2"
164# @VARIABLE: EPATCH_OPTS
165# @DESCRIPTION:
87# Default options for patch 166# Default options for patch:
167# @CODE
88# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 168# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
89# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 169# --no-backup-if-mismatch - do not leave .orig files behind
90# Set -E to automatically remove empty files. 170# -E - automatically remove empty files
171# @CODE
91EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 172EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
173# @VARIABLE: EPATCH_EXCLUDE
174# @DESCRIPTION:
92# List of patches not to apply. Not this is only file names, 175# List of patches not to apply. Note this is only file names,
93# and not the full path .. 176# and not the full path. Globs accepted.
94EPATCH_EXCLUDE="" 177EPATCH_EXCLUDE=""
178# @VARIABLE: EPATCH_SINGLE_MSG
179# @DESCRIPTION:
95# Change the printed message for a single patch. 180# Change the printed message for a single patch.
96EPATCH_SINGLE_MSG="" 181EPATCH_SINGLE_MSG=""
182# @VARIABLE: EPATCH_MULTI_MSG
183# @DESCRIPTION:
97# Change the printed message for multiple patches. 184# Change the printed message for multiple patches.
98EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 185EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
99# Force applying bulk patches even if not following the style: 186# @VARIABLE: EPATCH_FORCE
100# 187# @DESCRIPTION:
101# ??_${ARCH}_foo.${EPATCH_SUFFIX} 188# Only require patches to match EPATCH_SUFFIX rather than the extended
102# 189# arch naming style.
103EPATCH_FORCE="no" 190EPATCH_FORCE="no"
104 191
105# This function is for bulk patching, or in theory for just one 192# @FUNCTION: epatch
106# or two patches. 193# @USAGE: [patches] [dirs of patches]
194# @DESCRIPTION:
195# epatch is designed to greatly simplify the application of patches. It can
196# process patch files directly, or directories of patches. The patches may be
197# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
198# the -p option as epatch will automatically attempt -p0 to -p5 until things
199# apply successfully.
107# 200#
108# It should work with .bz2, .gz, .zip and plain text patches. 201# If you do not specify any options, then epatch will default to the directory
109# Currently all patches should be the same format. 202# specified by EPATCH_SOURCE.
110# 203#
111# You do not have to specify '-p' option to patch, as it will 204# When processing directories, epatch will apply all patches that match:
112# try with -p0 to -p5 until it succeed, or fail at -p5. 205# @CODE
113# 206# if ${EPATCH_FORCE} != "yes"
114# Above EPATCH_* variables can be used to control various defaults,
115# bug they should be left as is to ensure an ebuild can rely on
116# them for.
117#
118# Patches are applied in current directory.
119#
120# Bulk Patches should preferibly have the form of:
121#
122# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
208# else
209# *.${EPATCH_SUFFIX}
210# @CODE
211# The leading ?? are typically numbers used to force consistent patch ordering.
212# The arch field is used to apply patches only for the host architecture with
213# the special value of "all" means apply for everyone. Note that using values
214# other than "all" is highly discouraged -- you should apply patches all the
215# time and let architecture details be detected at configure/compile time.
123# 216#
124# For example: 217# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
218# for patches to apply.
125# 219#
126# 01_all_misc-fix.patch.bz2 220# Refer to the other EPATCH_xxx variables for more customization of behavior.
127# 02_sparc_another-fix.patch.bz2
128#
129# This ensures that there are a set order, and you can have ARCH
130# specific patches.
131#
132# If you however give an argument to epatch(), it will treat it as a
133# single patch that need to be applied if its a file. If on the other
134# hand its a directory, it will set EPATCH_SOURCE to this.
135#
136# <azarah@gentoo.org> (10 Nov 2002)
137#
138epatch() { 221epatch() {
139 _epatch_draw_line() { 222 _epatch_draw_line() {
223 # create a line of same length as input string
140 [[ -z $1 ]] && set "$(printf "%65s" '')" 224 [[ -z $1 ]] && set "$(printf "%65s" '')"
141 echo "${1//?/=}" 225 echo "${1//?/=}"
142 } 226 }
143 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
144 local PIPE_CMD=""
145 local STDERR_TARGET="${T}/$$.out"
146 local PATCH_TARGET="${T}/$$.patch"
147 local PATCH_SUFFIX=""
148 local SINGLE_PATCH="no"
149 local x=""
150 227
151 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 228 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
152 229
153 if [ "$#" -gt 1 ] 230 # Let the rest of the code process one user arg at a time --
154 then 231 # each arg may expand into multiple patches, and each arg may
232 # need to start off with the default global EPATCH_xxx values
233 if [[ $# -gt 1 ]] ; then
155 local m="" 234 local m
156 for m in "$@" ; do 235 for m in "$@" ; do
157 epatch "${m}" 236 epatch "${m}"
158 done 237 done
159 return 0 238 return 0
160 fi 239 fi
161 240
162 if [ -n "$1" -a -f "$1" ] 241 local SINGLE_PATCH="no"
163 then 242 # no args means process ${EPATCH_SOURCE}
243 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
244
245 if [[ -f $1 ]] ; then
164 SINGLE_PATCH="yes" 246 SINGLE_PATCH="yes"
165 247 set -- "$1"
166 local EPATCH_SOURCE="$1" 248 # Use the suffix from the single patch (localize it); the code
249 # below will find the suffix for us
167 local EPATCH_SUFFIX="${1##*\.}" 250 local EPATCH_SUFFIX=$1
168 251
169 elif [ -n "$1" -a -d "$1" ] 252 elif [[ -d $1 ]] ; then
170 then 253 # Some people like to make dirs of patches w/out suffixes (vim)
171 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
172 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
260
261 else
262 # sanity check ... if it isn't a dir or file, wtf man ?
263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
264 echo
265 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
266 eerror
267 eerror " ${EPATCH_SOURCE}"
268 eerror " ( ${EPATCH_SOURCE##*/} )"
269 echo
270 die "Cannot find \$EPATCH_SOURCE!"
271 fi
272
273 local PIPE_CMD
274 case ${EPATCH_SUFFIX##*\.} in
275 xz) PIPE_CMD="xz -dc" ;;
276 lzma) PIPE_CMD="lzma -dc" ;;
277 bz2) PIPE_CMD="bzip2 -dc" ;;
278 gz|Z|z) PIPE_CMD="gzip -dc" ;;
279 ZIP|zip) PIPE_CMD="unzip -p" ;;
280 *) ;;
281 esac
282
283 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
284
285 local x
286 for x in "$@" ; do
287 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
288 # didn't match anything, ignore continue on
289 [[ ! -f ${x} ]] && continue
290
291 local patchname=${x##*/}
292
293 # Apply single patches, or forced sets of patches, or
294 # patches with ARCH dependant names.
295 # ???_arch_foo.patch
296 # Else, skip this input altogether
297 local a=${patchname#*_} # strip the ???_
298 a=${a%%_*} # strip the _foo.patch
299 if ! [[ ${SINGLE_PATCH} == "yes" || \
300 ${EPATCH_FORCE} == "yes" || \
301 ${a} == all || \
302 ${a} == ${ARCH} ]]
173 then 303 then
174 local EPATCH_SOURCE="$1/*" 304 continue
305 fi
306
307 # Let people filter things dynamically
308 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
309 # let people use globs in the exclude
310 eshopts_push -o noglob
311
312 local ex
313 for ex in ${EPATCH_EXCLUDE} ; do
314 if [[ ${patchname} == ${ex} ]] ; then
315 eshopts_pop
316 continue 2
317 fi
318 done
319
320 eshopts_pop
321 fi
322
323 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
324 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
325 einfo "${EPATCH_SINGLE_MSG}"
326 else
327 einfo "Applying ${patchname} ..."
328 fi
175 else 329 else
176 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 330 einfo " ${patchname} ..."
177 fi 331 fi
178 else 332
179 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 333 # most of the time, there will only be one run per unique name,
180 then 334 # but if there are more, make sure we get unique log filenames
181 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 335 local STDERR_TARGET="${T}/${patchname}.out"
182 then 336 if [[ -e ${STDERR_TARGET} ]] ; then
183 EPATCH_SOURCE="$1" 337 STDERR_TARGET="${T}/${patchname}-$$.out"
338 fi
339
340 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
341
342 # Decompress the patch if need be
343 local count=0
344 local PATCH_TARGET
345 if [[ -n ${PIPE_CMD} ]] ; then
346 PATCH_TARGET="${T}/$$.patch"
347 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
348
349 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
184 fi 355 fi
356 else
357 PATCH_TARGET=${x}
358 fi
185 359
360 # Check for absolute paths in patches. If sandbox is disabled,
361 # people could (accidently) patch files in the root filesystem.
362 # Or trigger other unpleasantries #237667. So disallow -p0 on
363 # such patches.
364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
365 if [[ -n ${abs_paths} ]] ; then
366 count=1
367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
376
377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
378 while [[ ${count} -lt 5 ]] ; do
379 # Generate some useful debug info ...
380 (
381 _epatch_draw_line "***** ${patchname} *****"
186 echo 382 echo
187 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
384 echo
385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
391 ) >> "${STDERR_TARGET}"
392
393 if [ $? -eq 0 ] ; then
394 (
395 _epatch_draw_line "***** ${patchname} *****"
396 echo
397 echo "ACTUALLY APPLYING ${patchname} ..."
398 echo
399 _epatch_draw_line "***** ${patchname} *****"
400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
405 ) >> "${STDERR_TARGET}"
406
407 if [ $? -ne 0 ] ; then
408 echo
409 eerror "A dry-run of patch command succeeded, but actually"
410 eerror "applying the patch failed!"
411 #die "Real world sux compared to the dreamworld!"
412 count=5
413 fi
414 break
415 fi
416
417 : $(( count++ ))
418 done
419
420 # if we had to decompress the patch, delete the temp one
421 if [[ -n ${PIPE_CMD} ]] ; then
422 rm -f "${PATCH_TARGET}"
423 fi
424
425 if [[ ${count} -ge 5 ]] ; then
426 echo
427 eerror "Failed Patch: ${patchname} !"
428 eerror " ( ${PATCH_TARGET} )"
188 eerror 429 eerror
189 eerror " ${EPATCH_SOURCE}" 430 eerror "Include in your bugreport the contents of:"
190 eerror " ( ${EPATCH_SOURCE##*/} )" 431 eerror
432 eerror " ${STDERR_TARGET}"
191 echo 433 echo
192 die "Cannot find \$EPATCH_SOURCE!"
193 fi
194
195 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
196 fi
197
198 case ${EPATCH_SUFFIX##*\.} in
199 bz2)
200 PIPE_CMD="bzip2 -dc"
201 PATCH_SUFFIX="bz2"
202 ;;
203 gz|Z|z)
204 PIPE_CMD="gzip -dc"
205 PATCH_SUFFIX="gz"
206 ;;
207 ZIP|zip)
208 PIPE_CMD="unzip -p"
209 PATCH_SUFFIX="zip"
210 ;;
211 *)
212 PIPE_CMD="cat"
213 PATCH_SUFFIX="patch"
214 ;;
215 esac
216
217 if [ "${SINGLE_PATCH}" = "no" ]
218 then
219 einfo "${EPATCH_MULTI_MSG}"
220 fi
221 for x in ${EPATCH_SOURCE}
222 do
223 # New ARCH dependant patch naming scheme ...
224 #
225 # ???_arch_foo.patch
226 #
227 if [ -f ${x} ] && \
228 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
229 [ "${EPATCH_FORCE}" = "yes" ])
230 then
231 local count=0
232 local popts="${EPATCH_OPTS}"
233 local patchname=${x##*/}
234
235 if [ -n "${EPATCH_EXCLUDE}" ]
236 then
237 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
238 then
239 continue
240 fi
241 fi
242
243 if [ "${SINGLE_PATCH}" = "yes" ]
244 then
245 if [ -n "${EPATCH_SINGLE_MSG}" ]
246 then
247 einfo "${EPATCH_SINGLE_MSG}"
248 else
249 einfo "Applying ${patchname} ..."
250 fi
251 else
252 einfo " ${patchname} ..."
253 fi
254
255 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
256 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
257
258 # Allow for prefix to differ ... im lazy, so shoot me :/
259 while [ "${count}" -lt 5 ]
260 do
261 # Generate some useful debug info ...
262 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
264
265 if [ "${PATCH_SUFFIX}" != "patch" ]
266 then
267 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
268 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
269 else
270 PATCH_TARGET="${x}"
271 fi
272
273 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275
276 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
278
279 if [ "${PATCH_SUFFIX}" != "patch" ]
280 then
281 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
282 then
283 echo
284 eerror "Could not extract patch!"
285 #die "Could not extract patch!"
286 count=5
287 break
288 fi
289 fi
290
291 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
292 then
293 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
294 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
295 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
297 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
298
299 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
300 _epatch_assert
301
302 if [ "$?" -ne 0 ]
303 then
304 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305 echo
306 eerror "A dry-run of patch command succeeded, but actually"
307 eerror "applying the patch failed!"
308 #die "Real world sux compared to the dreamworld!"
309 count=5
310 fi
311
312 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
313
314 break
315 fi
316
317 count=$((count + 1))
318 done
319
320 if [ "${PATCH_SUFFIX}" != "patch" ]
321 then
322 rm -f ${PATCH_TARGET}
323 fi
324
325 if [ "${count}" -eq 5 ]
326 then
327 echo
328 eerror "Failed Patch: ${patchname} !"
329 eerror " ( ${PATCH_TARGET} )"
330 eerror
331 eerror "Include in your bugreport the contents of:"
332 eerror
333 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
334 echo
335 die "Failed Patch: ${patchname}!" 434 die "Failed Patch: ${patchname}!"
336 fi 435 fi
337 436
338 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 437 # if everything worked, delete the patch log
339 438 rm -f "${STDERR_TARGET}"
340 eend 0 439 eend 0
341 fi
342 done 440 done
343 if [ "${SINGLE_PATCH}" = "no" ] 441
344 then 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
345 einfo "Done with patching" 443 : # everything worked
444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
472epatch_user() {
473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
478
479 # don't clobber any EPATCH vars that the parent might want
480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
483 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
485 if [[ -d ${EPATCH_SOURCE} ]] ; then
486 EPATCH_SOURCE=${EPATCH_SOURCE} \
487 EPATCH_SUFFIX="patch" \
488 EPATCH_FORCE="yes" \
489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
490 epatch
491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
346 fi 493 fi
494 done
495 echo "none" > "${applied}"
496 return 1
347} 497}
348 498
499# @FUNCTION: emktemp
500# @USAGE: [temp dir]
501# @DESCRIPTION:
349# Cheap replacement for when debianutils (and thus mktemp) 502# Cheap replacement for when debianutils (and thus mktemp)
350# does not exist on the users system 503# does not exist on the users system.
351# vapier@gentoo.org
352#
353# Takes just 1 optional parameter (the directory to create tmpfile in)
354emktemp() { 504emktemp() {
355 local exe="touch" 505 local exe="touch"
356 [[ $1 == -d ]] && exe="mkdir" && shift 506 [[ $1 == -d ]] && exe="mkdir" && shift
357 local topdir=$1 507 local topdir=$1
358 508
360 [[ -z ${T} ]] \ 510 [[ -z ${T} ]] \
361 && topdir="/tmp" \ 511 && topdir="/tmp" \
362 || topdir=${T} 512 || topdir=${T}
363 fi 513 fi
364 514
365 if [[ -z $(type -p mktemp) ]] ; then 515 if ! type -P mktemp > /dev/null ; then
516 # system lacks `mktemp` so we have to fake it
366 local tmp=/ 517 local tmp=/
367 while [[ -e ${tmp} ]] ; do 518 while [[ -e ${tmp} ]] ; do
368 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 519 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
369 done 520 done
370 ${exe} "${tmp}" || ${exe} -p "${tmp}" 521 ${exe} "${tmp}" || ${exe} -p "${tmp}"
371 echo "${tmp}" 522 echo "${tmp}"
372 else 523 else
524 # the args here will give slightly wierd names on BSD,
525 # but should produce a usable file on all userlands
373 if [[ ${exe} == "touch" ]] ; then 526 if [[ ${exe} == "touch" ]] ; then
374 [[ ${USERLAND} == "GNU" ]] \
375 && mktemp -p "${topdir}" \
376 || TMPDIR="${topdir}" mktemp -t tmp 527 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
377 else 528 else
378 [[ ${USERLAND} == "GNU" ]] \
379 && mktemp -d "${topdir}" \
380 || TMPDIR="${topdir}" mktemp -dt tmp 529 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
381 fi
382 fi 530 fi
531 fi
383} 532}
384 533
534# @FUNCTION: egetent
535# @USAGE: <database> <key>
536# @MAINTAINER:
537# base-system@gentoo.org (Linux)
538# Joe Jezak <josejx@gmail.com> (OS X)
539# usata@gentoo.org (OS X)
540# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
541# @DESCRIPTION:
385# Small wrapper for getent (Linux), nidump (Mac OS X), 542# Small wrapper for getent (Linux),
543# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
386# and pw (FreeBSD) used in enewuser()/enewgroup() 544# and pw (FreeBSD) used in enewuser()/enewgroup()
387# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
388# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
389#
390# egetent(database, key)
391egetent() { 545egetent() {
392 case ${CHOST} in 546 case ${CHOST} in
393 *-darwin*) 547 *-darwin[678])
394 case "$2" in 548 case "$2" in
395 *[!0-9]*) # Non numeric 549 *[!0-9]*) # Non numeric
396 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 550 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
397 ;; 551 ;;
398 *) # Numeric 552 *) # Numeric
399 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 553 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
554 ;;
555 esac
556 ;;
557 *-darwin*)
558 local mytype=$1
559 [[ "passwd" == $mytype ]] && mytype="Users"
560 [[ "group" == $mytype ]] && mytype="Groups"
561 case "$2" in
562 *[!0-9]*) # Non numeric
563 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
564 ;;
565 *) # Numeric
566 local mykey="UniqueID"
567 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
568 dscl . -search /$mytype $mykey $2 2>/dev/null
400 ;; 569 ;;
401 esac 570 esac
402 ;; 571 ;;
403 *-freebsd*|*-dragonfly*) 572 *-freebsd*|*-dragonfly*)
404 local opts action="user" 573 local opts action="user"
419 getent "$1" "$2" 588 getent "$1" "$2"
420 ;; 589 ;;
421 esac 590 esac
422} 591}
423 592
424# Simplify/standardize adding users to the system 593# @FUNCTION: enewuser
425# vapier@gentoo.org 594# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
426# 595# @DESCRIPTION:
427# enewuser(username, uid, shell, homedir, groups, extra options) 596# Same as enewgroup, you are not required to understand how to properly add
428# 597# a user to the system. The only required parameter is the username.
429# Default values if you do not specify any: 598# Default uid is (pass -1 for this) next available, default shell is
430# username: REQUIRED ! 599# /bin/false, default homedir is /dev/null, there are no default groups,
431# uid: next available (see useradd(8)) 600# and default params sets the comment as 'added by portage for ${PN}'.
432# note: pass -1 to get default behavior
433# shell: /bin/false
434# homedir: /dev/null
435# groups: none
436# extra: comment of 'added by portage for ${PN}'
437enewuser() { 601enewuser() {
438 case ${EBUILD_PHASE} in 602 case ${EBUILD_PHASE} in
439 unpack|compile|test|install) 603 unpack|compile|test|install)
440 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 604 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
441 eerror "Package fails at QA and at life. Please file a bug." 605 eerror "Package fails at QA and at life. Please file a bug."
448 eerror "No username specified !" 612 eerror "No username specified !"
449 die "Cannot call enewuser without a username" 613 die "Cannot call enewuser without a username"
450 fi 614 fi
451 615
452 # lets see if the username already exists 616 # lets see if the username already exists
453 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then 617 if [[ -n $(egetent passwd "${euser}") ]] ; then
454 return 0 618 return 0
455 fi 619 fi
456 einfo "Adding user '${euser}' to your system ..." 620 einfo "Adding user '${euser}' to your system ..."
457 621
458 # options to pass to useradd 622 # options to pass to useradd
459 local opts= 623 local opts=
460 624
461 # handle uid 625 # handle uid
462 local euid=$1; shift 626 local euid=$1; shift
463 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then 627 if [[ -n ${euid} && ${euid} != -1 ]] ; then
464 if [[ ${euid} -gt 0 ]] ; then 628 if [[ ${euid} -gt 0 ]] ; then
465 if [[ ! -z $(egetent passwd ${euid}) ]] ; then 629 if [[ -n $(egetent passwd ${euid}) ]] ; then
466 euid="next" 630 euid="next"
467 fi 631 fi
468 else 632 else
469 eerror "Userid given but is not greater than 0 !" 633 eerror "Userid given but is not greater than 0 !"
470 die "${euid} is not a valid UID" 634 die "${euid} is not a valid UID"
471 fi 635 fi
472 else 636 else
473 euid="next" 637 euid="next"
474 fi 638 fi
475 if [[ ${euid} == "next" ]] ; then 639 if [[ ${euid} == "next" ]] ; then
476 for euid in $(seq 101 999) ; do 640 for ((euid = 101; euid <= 999; euid++)); do
477 [[ -z $(egetent passwd ${euid}) ]] && break 641 [[ -z $(egetent passwd ${euid}) ]] && break
478 done 642 done
479 fi 643 fi
480 opts="${opts} -u ${euid}" 644 opts="${opts} -u ${euid}"
481 einfo " - Userid: ${euid}" 645 einfo " - Userid: ${euid}"
495 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 659 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
496 [[ -x ${ROOT}${shell} ]] && break 660 [[ -x ${ROOT}${shell} ]] && break
497 done 661 done
498 662
499 if [[ ${shell} == "/dev/null" ]] ; then 663 if [[ ${shell} == "/dev/null" ]] ; then
500 eerror "Unable to identify the shell to use" 664 eerror "Unable to identify the shell to use, proceeding with userland default."
501 die "Unable to identify the shell to use" 665 case ${USERLAND} in
666 GNU) shell="/bin/false" ;;
667 BSD) shell="/sbin/nologin" ;;
668 Darwin) shell="/usr/sbin/nologin" ;;
669 *) die "Unable to identify the default shell for userland ${USERLAND}"
670 esac
502 fi 671 fi
503 672
504 eshell=${shell} 673 eshell=${shell}
505 fi 674 fi
506 einfo " - Shell: ${eshell}" 675 einfo " - Shell: ${eshell}"
604 fi 773 fi
605 ;; 774 ;;
606 775
607 *) 776 *)
608 if [[ -z $@ ]] ; then 777 if [[ -z $@ ]] ; then
609 useradd ${opts} ${euser} \ 778 useradd -r ${opts} \
610 -c "added by portage for ${PN}" \ 779 -c "added by portage for ${PN}" \
780 ${euser} \
611 || die "enewuser failed" 781 || die "enewuser failed"
612 else 782 else
613 einfo " - Extra: $@" 783 einfo " - Extra: $@"
614 useradd ${opts} ${euser} "$@" \ 784 useradd -r ${opts} "$@" \
785 ${euser} \
615 || die "enewuser failed" 786 || die "enewuser failed"
616 fi 787 fi
617 ;; 788 ;;
618 esac 789 esac
619 790
625 fi 796 fi
626 797
627 export SANDBOX_ON=${oldsandbox} 798 export SANDBOX_ON=${oldsandbox}
628} 799}
629 800
630# Simplify/standardize adding groups to the system 801# @FUNCTION: enewgroup
631# vapier@gentoo.org 802# @USAGE: <group> [gid]
632# 803# @DESCRIPTION:
633# enewgroup(group, gid) 804# This function does not require you to understand how to properly add a
634# 805# group to the system. Just give it a group name to add and enewgroup will
635# Default values if you do not specify any: 806# do the rest. You may specify the gid for the group or allow the group to
636# groupname: REQUIRED ! 807# allocate the next available one.
637# gid: next available (see groupadd(8))
638# extra: none
639enewgroup() { 808enewgroup() {
640 case ${EBUILD_PHASE} in 809 case ${EBUILD_PHASE} in
641 unpack|compile|test|install) 810 unpack|compile|test|install)
642 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 811 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
643 eerror "Package fails at QA and at life. Please file a bug." 812 eerror "Package fails at QA and at life. Please file a bug."
651 eerror "No group specified !" 820 eerror "No group specified !"
652 die "Cannot call enewgroup without a group" 821 die "Cannot call enewgroup without a group"
653 fi 822 fi
654 823
655 # see if group already exists 824 # see if group already exists
656 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ] 825 if [[ -n $(egetent group "${egroup}") ]]; then
657 then
658 return 0 826 return 0
659 fi 827 fi
660 einfo "Adding group '${egroup}' to your system ..." 828 einfo "Adding group '${egroup}' to your system ..."
661 829
662 # options to pass to useradd 830 # options to pass to useradd
705 fi 873 fi
706 874
707 # If we need the next available 875 # If we need the next available
708 case ${egid} in 876 case ${egid} in
709 *[!0-9]*) # Non numeric 877 *[!0-9]*) # Non numeric
710 for egid in $(seq 101 999); do 878 for ((egid = 101; egid <= 999; egid++)); do
711 [ -z "`egetent group ${egid}`" ] && break 879 [[ -z $(egetent group ${egid}) ]] && break
712 done 880 done
713 esac 881 esac
714 dscl . create /groups/${egroup} gid ${egid} 882 dscl . create /groups/${egroup} gid ${egid}
715 dscl . create /groups/${egroup} passwd '*' 883 dscl . create /groups/${egroup} passwd '*'
716 ;; 884 ;;
717 885
718 *-freebsd*|*-dragonfly*) 886 *-freebsd*|*-dragonfly*)
719 case ${egid} in 887 case ${egid} in
720 *[!0-9]*) # Non numeric 888 *[!0-9]*) # Non numeric
721 for egid in $(seq 101 999); do 889 for ((egid = 101; egid <= 999; egid++)); do
722 [ -z "`egetent group ${egid}`" ] && break 890 [[ -z $(egetent group ${egid}) ]] && break
723 done 891 done
724 esac 892 esac
725 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 893 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
726 ;; 894 ;;
727 895
728 *-netbsd*) 896 *-netbsd*)
729 case ${egid} in 897 case ${egid} in
730 *[!0-9]*) # Non numeric 898 *[!0-9]*) # Non numeric
731 for egid in $(seq 101 999); do 899 for ((egid = 101; egid <= 999; egid++)); do
732 [ -z "`egetent group ${egid}`" ] && break 900 [[ -z $(egetent group ${egid}) ]] && break
733 done 901 done
734 esac 902 esac
735 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 903 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
736 ;; 904 ;;
737 905
738 *) 906 *)
907 # We specify -r so that we get a GID in the system range from login.defs
739 groupadd ${opts} ${egroup} || die "enewgroup failed" 908 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
740 ;; 909 ;;
741 esac 910 esac
742 export SANDBOX_ON="${oldsandbox}" 911 export SANDBOX_ON="${oldsandbox}"
743} 912}
744 913
745# Simple script to replace 'dos2unix' binaries 914# @FUNCTION: edos2unix
746# vapier@gentoo.org 915# @USAGE: <file> [more files ...]
747# 916# @DESCRIPTION:
748# edos2unix(file, <more files> ...) 917# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
918# to remove all of these text utilities from DEPEND variables because this
919# is a script based solution. Just give it a list of files to convert and
920# they will all be changed from the DOS CRLF format to the UNIX LF format.
749edos2unix() { 921edos2unix() {
750 for f in "$@" 922 echo "$@" | xargs sed -i 's/\r$//'
751 do
752 cp "${f}" ${T}/edos2unix
753 sed 's/\r$//' ${T}/edos2unix > "${f}"
754 done
755} 923}
756
757
758##############################################################
759# START: Handle .desktop files and menu entries #
760# maybe this should be separated into a new eclass some time #
761# lanius@gentoo.org #
762##############################################################
763 924
764# Make a desktop file ! 925# Make a desktop file !
765# Great for making those icons in kde/gnome startmenu ! 926# Great for making those icons in kde/gnome startmenu !
766# Amaze your friends ! Get the women ! Join today ! 927# Amaze your friends ! Get the women ! Join today !
767# 928#
768# make_desktop_entry(<command>, [name], [icon], [type], [path]) 929# make_desktop_entry(<command>, [name], [icon], [type], [fields])
769# 930#
770# binary: what command does the app run with ? 931# binary: what command does the app run with ?
771# name: the name that will show up in the menu 932# name: the name that will show up in the menu
772# icon: give your little like a pretty little icon ... 933# icon: give your little like a pretty little icon ...
773# this can be relative (to /usr/share/pixmaps) or 934# this can be relative (to /usr/share/pixmaps) or
774# a full path to an icon 935# a full path to an icon
775# type: what kind of application is this ? for categories: 936# type: what kind of application is this ? for categories:
776# http://www.freedesktop.org/Standards/desktop-entry-spec 937# http://standards.freedesktop.org/menu-spec/latest/apa.html
777# path: if your app needs to startup in a specific dir 938# fields: extra fields to append to the desktop file; a printf string
778make_desktop_entry() { 939make_desktop_entry() {
779 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 940 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
780 941
781 local exec=${1} 942 local exec=${1}
782 local name=${2:-${PN}} 943 local name=${2:-${PN}}
783 local icon=${3:-${PN}.png} 944 local icon=${3:-${PN}}
784 local type=${4} 945 local type=${4}
785 local path=${5} 946 local fields=${5}
786 947
787 if [[ -z ${type} ]] ; then 948 if [[ -z ${type} ]] ; then
788 local catmaj=${CATEGORY%%-*} 949 local catmaj=${CATEGORY%%-*}
789 local catmin=${CATEGORY##*-} 950 local catmin=${CATEGORY##*-}
790 case ${catmaj} in 951 case ${catmaj} in
791 app) 952 app)
792 case ${catmin} in 953 case ${catmin} in
954 accessibility) type=Accessibility;;
793 admin) type=System;; 955 admin) type=System;;
956 antivirus) type=System;;
957 arch) type=Archiving;;
958 backup) type=Archiving;;
794 cdr) type=DiscBurning;; 959 cdr) type=DiscBurning;;
795 dicts) type=Dictionary;; 960 dicts) type=Dictionary;;
961 doc) type=Documentation;;
796 editors) type=TextEditor;; 962 editors) type=TextEditor;;
797 emacs) type=TextEditor;; 963 emacs) type=TextEditor;;
798 emulation) type=Emulator;; 964 emulation) type=Emulator;;
799 laptop) type=HardwareSettings;; 965 laptop) type=HardwareSettings;;
800 office) type=Office;; 966 office) type=Office;;
967 pda) type=PDA;;
801 vim) type=TextEditor;; 968 vim) type=TextEditor;;
802 xemacs) type=TextEditor;; 969 xemacs) type=TextEditor;;
803 *) type=;;
804 esac 970 esac
805 ;; 971 ;;
806 972
807 dev) 973 dev)
808 type="Development" 974 type="Development"
809 ;; 975 ;;
810 976
811 games) 977 games)
812 case ${catmin} in 978 case ${catmin} in
813 action) type=ActionGame;; 979 action|fps) type=ActionGame;;
814 arcade) type=ArcadeGame;; 980 arcade) type=ArcadeGame;;
815 board) type=BoardGame;; 981 board) type=BoardGame;;
816 kid) type=KidsGame;;
817 emulation) type=Emulator;; 982 emulation) type=Emulator;;
983 kids) type=KidsGame;;
818 puzzle) type=LogicGame;; 984 puzzle) type=LogicGame;;
985 roguelike) type=RolePlaying;;
819 rpg) type=RolePlaying;; 986 rpg) type=RolePlaying;;
820 roguelike) type=RolePlaying;;
821 simulation) type=Simulation;; 987 simulation) type=Simulation;;
822 sports) type=SportsGame;; 988 sports) type=SportsGame;;
823 strategy) type=StrategyGame;; 989 strategy) type=StrategyGame;;
824 *) type=;;
825 esac 990 esac
826 type="Game;${type}" 991 type="Game;${type}"
827 ;; 992 ;;
828 993
994 gnome)
995 type="Gnome;GTK"
996 ;;
997
998 kde)
999 type="KDE;Qt"
1000 ;;
1001
829 mail) 1002 mail)
830 type="Network;Email" 1003 type="Network;Email"
831 ;; 1004 ;;
832 1005
833 media) 1006 media)
834 case ${catmin} in 1007 case ${catmin} in
1008 gfx)
835 gfx) type=Graphics;; 1009 type=Graphics
1010 ;;
1011 *)
1012 case ${catmin} in
836 radio) type=Tuner;; 1013 radio) type=Tuner;;
837 sound) type=Audio;; 1014 sound) type=Audio;;
838 tv) type=TV;; 1015 tv) type=TV;;
839 video) type=Video;; 1016 video) type=Video;;
840 *) type=;; 1017 esac
1018 type="AudioVideo;${type}"
1019 ;;
841 esac 1020 esac
842 type="AudioVideo;${type}"
843 ;; 1021 ;;
844 1022
845 net) 1023 net)
846 case ${catmin} in 1024 case ${catmin} in
847 dialup) type=Dialup;; 1025 dialup) type=Dialup;;
850 irc) type=IRCClient;; 1028 irc) type=IRCClient;;
851 mail) type=Email;; 1029 mail) type=Email;;
852 news) type=News;; 1030 news) type=News;;
853 nntp) type=News;; 1031 nntp) type=News;;
854 p2p) type=FileTransfer;; 1032 p2p) type=FileTransfer;;
855 *) type=;; 1033 voip) type=Telephony;;
856 esac 1034 esac
857 type="Network;${type}" 1035 type="Network;${type}"
858 ;; 1036 ;;
859 1037
860 sci) 1038 sci)
861 case ${catmin} in 1039 case ${catmin} in
862 astro*) type=Astronomy;; 1040 astro*) type=Astronomy;;
863 bio*) type=Biology;; 1041 bio*) type=Biology;;
864 calc*) type=Calculator;; 1042 calc*) type=Calculator;;
865 chem*) type=Chemistry;; 1043 chem*) type=Chemistry;;
1044 elec*) type=Electronics;;
866 geo*) type=Geology;; 1045 geo*) type=Geology;;
867 math*) type=Math;; 1046 math*) type=Math;;
868 *) type=;; 1047 physics) type=Physics;;
1048 visual*) type=DataVisualization;;
869 esac 1049 esac
870 type="Science;${type}" 1050 type="Education;Science;${type}"
1051 ;;
1052
1053 sys)
1054 type="System"
871 ;; 1055 ;;
872 1056
873 www) 1057 www)
874 case ${catmin} in 1058 case ${catmin} in
875 client) type=WebBrowser;; 1059 client) type=WebBrowser;;
876 *) type=;;
877 esac 1060 esac
878 type="Network" 1061 type="Network;${type}"
879 ;; 1062 ;;
880 1063
881 *) 1064 *)
882 type= 1065 type=
883 ;; 1066 ;;
886 if [ "${SLOT}" == "0" ] ; then 1069 if [ "${SLOT}" == "0" ] ; then
887 local desktop_name="${PN}" 1070 local desktop_name="${PN}"
888 else 1071 else
889 local desktop_name="${PN}-${SLOT}" 1072 local desktop_name="${PN}-${SLOT}"
890 fi 1073 fi
891 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 1074 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
892# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1075 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
893 1076
1077 # Don't append another ";" when a valid category value is provided.
1078 type=${type%;}${type:+;}
1079
1080 eshopts_push -s extglob
1081 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1082 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1083 ewarn "allowed in .desktop files if the value is not an absolute path."
1084 icon=${icon%.@(xpm|png|svg)}
1085 fi
1086 eshopts_pop
1087
1088 cat <<-EOF > "${desktop}"
894echo "[Desktop Entry] 1089 [Desktop Entry]
895Encoding=UTF-8
896Version=0.9.2
897Name=${name} 1090 Name=${name}
898Type=Application 1091 Type=Application
899Comment=${DESCRIPTION} 1092 Comment=${DESCRIPTION}
900Exec=${exec} 1093 Exec=${exec}
901TryExec=${exec%% *} 1094 TryExec=${exec%% *}
902Path=${path}
903Icon=${icon} 1095 Icon=${icon}
904Categories=Application;${type};" > "${desktop}" 1096 Categories=${type}
1097 EOF
1098
1099 if [[ ${fields:-=} != *=* ]] ; then
1100 # 5th arg used to be value to Path=
1101 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1102 fields="Path=${fields}"
1103 fi
1104 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
905 1105
906 ( 1106 (
907 # wrap the env here so that the 'insinto' call 1107 # wrap the env here so that the 'insinto' call
908 # doesn't corrupt the env of the caller 1108 # doesn't corrupt the env of the caller
909 insinto /usr/share/applications 1109 insinto /usr/share/applications
910 doins "${desktop}" 1110 doins "${desktop}"
911 ) 1111 ) || die "installing desktop file failed"
912} 1112}
913 1113
914# Make a GDM/KDM Session file 1114# @FUNCTION: validate_desktop_entries
915# 1115# @USAGE: [directories]
916# make_desktop_entry(<title>, <command>) 1116# @MAINTAINER:
917# title: File to execute to start the Window Manager 1117# Carsten Lohrke <carlo@gentoo.org>
918# command: Name of the Window Manager 1118# @DESCRIPTION:
1119# Validate desktop entries using desktop-file-utils
1120validate_desktop_entries() {
1121 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1122 einfo "Checking desktop entry validity"
1123 local directories=""
1124 for d in /usr/share/applications $@ ; do
1125 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1126 done
1127 if [[ -n ${directories} ]] ; then
1128 for FILE in $(find ${directories} -name "*\.desktop" \
1129 -not -path '*.hidden*' | sort -u 2>/dev/null)
1130 do
1131 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1132 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1133 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1134 done
1135 fi
1136 echo ""
1137 else
1138 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1139 fi
1140}
919 1141
1142# @FUNCTION: make_session_desktop
1143# @USAGE: <title> <command> [command args...]
1144# @DESCRIPTION:
1145# Make a GDM/KDM Session file. The title is the file to execute to start the
1146# Window Manager. The command is the name of the Window Manager.
1147#
1148# You can set the name of the file via the ${wm} variable.
920make_session_desktop() { 1149make_session_desktop() {
921 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1150 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
922 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1151 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
923 1152
924 local title=$1 1153 local title=$1
925 local command=$2 1154 local command=$2
926 local desktop=${T}/${wm}.desktop 1155 local desktop=${T}/${wm:-${PN}}.desktop
1156 shift 2
927 1157
1158 cat <<-EOF > "${desktop}"
928echo "[Desktop Entry] 1159 [Desktop Entry]
929Encoding=UTF-8
930Name=${title} 1160 Name=${title}
931Comment=This session logs you into ${title} 1161 Comment=This session logs you into ${title}
932Exec=${command} 1162 Exec=${command} $*
933TryExec=${command} 1163 TryExec=${command}
934Type=Application" > "${desktop}" 1164 Type=XSession
1165 EOF
935 1166
1167 (
1168 # wrap the env here so that the 'insinto' call
1169 # doesn't corrupt the env of the caller
936 insinto /usr/share/xsessions 1170 insinto /usr/share/xsessions
937 doins "${desktop}" 1171 doins "${desktop}"
1172 )
938} 1173}
939 1174
1175# @FUNCTION: domenu
1176# @USAGE: <menus>
1177# @DESCRIPTION:
1178# Install the list of .desktop menu files into the appropriate directory
1179# (/usr/share/applications).
940domenu() { 1180domenu() {
1181 (
1182 # wrap the env here so that the 'insinto' call
1183 # doesn't corrupt the env of the caller
941 local i j 1184 local i j ret=0
942 insinto /usr/share/applications 1185 insinto /usr/share/applications
943 for i in "$@" ; do 1186 for i in "$@" ; do
944 if [[ -f ${i} ]] ; then 1187 if [[ -f ${i} ]] ; then
945 doins "${i}" 1188 doins "${i}"
1189 ((ret+=$?))
946 elif [[ -d ${i} ]] ; then 1190 elif [[ -d ${i} ]] ; then
947 for j in "${i}"/*.desktop ; do 1191 for j in "${i}"/*.desktop ; do
948 doins "${j}" 1192 doins "${j}"
1193 ((ret+=$?))
949 done 1194 done
1195 else
1196 ((++ret))
950 fi 1197 fi
951 done 1198 done
1199 exit ${ret}
1200 )
952} 1201}
1202
1203# @FUNCTION: newmenu
1204# @USAGE: <menu> <newname>
1205# @DESCRIPTION:
1206# Like all other new* functions, install the specified menu as newname.
953newmenu() { 1207newmenu() {
1208 (
1209 # wrap the env here so that the 'insinto' call
1210 # doesn't corrupt the env of the caller
954 insinto /usr/share/applications 1211 insinto /usr/share/applications
955 newins "$1" "$2" 1212 newins "$@"
1213 )
956} 1214}
957 1215
1216# @FUNCTION: doicon
1217# @USAGE: <list of icons>
1218# @DESCRIPTION:
1219# Install the list of icons into the icon directory (/usr/share/pixmaps).
1220# This is useful in conjunction with creating desktop/menu files.
958doicon() { 1221doicon() {
1222 (
1223 # wrap the env here so that the 'insinto' call
1224 # doesn't corrupt the env of the caller
959 local i j 1225 local i j ret
960 insinto /usr/share/pixmaps 1226 insinto /usr/share/pixmaps
961 for i in "$@" ; do 1227 for i in "$@" ; do
962 if [[ -f ${i} ]] ; then 1228 if [[ -f ${i} ]] ; then
963 doins "${i}" 1229 doins "${i}"
1230 ((ret+=$?))
964 elif [[ -d ${i} ]] ; then 1231 elif [[ -d ${i} ]] ; then
965 for j in "${i}"/*.png ; do 1232 for j in "${i}"/*.png ; do
966 doins "${j}" 1233 doins "${j}"
1234 ((ret+=$?))
967 done 1235 done
1236 else
1237 ((++ret))
968 fi 1238 fi
969 done 1239 done
1240 exit ${ret}
1241 )
970} 1242}
1243
1244# @FUNCTION: newicon
1245# @USAGE: <icon> <newname>
1246# @DESCRIPTION:
1247# Like all other new* functions, install the specified icon as newname.
971newicon() { 1248newicon() {
1249 (
1250 # wrap the env here so that the 'insinto' call
1251 # doesn't corrupt the env of the caller
972 insinto /usr/share/pixmaps 1252 insinto /usr/share/pixmaps
973 newins "$1" "$2" 1253 newins "$@"
1254 )
974} 1255}
975
976##############################################################
977# END: Handle .desktop files and menu entries #
978##############################################################
979
980 1256
981# for internal use only (unpack_pdv and unpack_makeself) 1257# for internal use only (unpack_pdv and unpack_makeself)
982find_unpackable_file() { 1258find_unpackable_file() {
983 local src=$1 1259 local src=$1
984 if [[ -z ${src} ]] ; then 1260 if [[ -z ${src} ]] ; then
994 fi 1270 fi
995 [[ ! -e ${src} ]] && return 1 1271 [[ ! -e ${src} ]] && return 1
996 echo "${src}" 1272 echo "${src}"
997} 1273}
998 1274
1275# @FUNCTION: unpack_pdv
1276# @USAGE: <file to unpack> <size of off_t>
1277# @DESCRIPTION:
999# Unpack those pesky pdv generated files ... 1278# Unpack those pesky pdv generated files ...
1000# They're self-unpacking programs with the binary package stuffed in 1279# They're self-unpacking programs with the binary package stuffed in
1001# the middle of the archive. Valve seems to use it a lot ... too bad 1280# the middle of the archive. Valve seems to use it a lot ... too bad
1002# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1281# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1003# 1282#
1004# Usage: unpack_pdv [file to unpack] [size of off_t]
1005# - you have to specify the off_t size ... i have no idea how to extract that 1283# You have to specify the off_t size ... I have no idea how to extract that
1006# information out of the binary executable myself. basically you pass in 1284# information out of the binary executable myself. Basically you pass in
1007# the size of the off_t type (in bytes) on the machine that built the pdv 1285# the size of the off_t type (in bytes) on the machine that built the pdv
1286# archive.
1287#
1008# archive. one way to determine this is by running the following commands: 1288# One way to determine this is by running the following commands:
1289#
1290# @CODE
1009# strings <pdv archive> | grep lseek 1291# strings <pdv archive> | grep lseek
1010# strace -elseek <pdv archive> 1292# strace -elseek <pdv archive>
1293# @CODE
1294#
1011# basically look for the first lseek command (we do the strings/grep because 1295# Basically look for the first lseek command (we do the strings/grep because
1012# sometimes the function call is _llseek or something) and steal the 2nd 1296# sometimes the function call is _llseek or something) and steal the 2nd
1013# parameter. here is an example: 1297# parameter. Here is an example:
1298#
1299# @CODE
1014# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1300# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1015# lseek 1301# lseek
1016# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1302# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1017# lseek(3, -4, SEEK_END) = 2981250 1303# lseek(3, -4, SEEK_END) = 2981250
1304# @CODE
1305#
1018# thus we would pass in the value of '4' as the second parameter. 1306# Thus we would pass in the value of '4' as the second parameter.
1019unpack_pdv() { 1307unpack_pdv() {
1020 local src=$(find_unpackable_file $1) 1308 local src=$(find_unpackable_file "$1")
1021 local sizeoff_t=$2 1309 local sizeoff_t=$2
1022 1310
1023 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1311 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1024 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1312 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1025 1313
1026 local shrtsrc=$(basename "${src}") 1314 local shrtsrc=$(basename "${src}")
1027 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1315 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1028 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1316 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1029 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1317 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1030 1318
1031 # grab metadata for debug reasons 1319 # grab metadata for debug reasons
1032 local metafile="$(emktemp)" 1320 local metafile=$(emktemp)
1033 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1321 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1034 1322
1035 # rip out the final file name from the metadata 1323 # rip out the final file name from the metadata
1036 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1324 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1037 datafile="`basename ${datafile}`" 1325 datafile=$(basename "${datafile}")
1038 1326
1039 # now lets uncompress/untar the file if need be 1327 # now lets uncompress/untar the file if need be
1040 local tmpfile="$(emktemp)" 1328 local tmpfile=$(emktemp)
1041 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1329 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1042 1330
1043 local iscompressed="`file -b ${tmpfile}`" 1331 local iscompressed=$(file -b "${tmpfile}")
1044 if [ "${iscompressed:0:8}" == "compress" ] ; then 1332 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1045 iscompressed=1 1333 iscompressed=1
1046 mv ${tmpfile}{,.Z} 1334 mv ${tmpfile}{,.Z}
1047 gunzip ${tmpfile} 1335 gunzip ${tmpfile}
1048 else 1336 else
1049 iscompressed=0 1337 iscompressed=0
1050 fi 1338 fi
1051 local istar="`file -b ${tmpfile}`" 1339 local istar=$(file -b "${tmpfile}")
1052 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1340 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1053 istar=1 1341 istar=1
1054 else 1342 else
1055 istar=0 1343 istar=0
1056 fi 1344 fi
1057 1345
1085 true 1373 true
1086 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1374 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1087 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1375 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1088} 1376}
1089 1377
1378# @FUNCTION: unpack_makeself
1379# @USAGE: [file to unpack] [offset] [tail|dd]
1380# @DESCRIPTION:
1090# Unpack those pesky makeself generated files ... 1381# Unpack those pesky makeself generated files ...
1091# They're shell scripts with the binary package tagged onto 1382# They're shell scripts with the binary package tagged onto
1092# the end of the archive. Loki utilized the format as does 1383# the end of the archive. Loki utilized the format as does
1093# many other game companies. 1384# many other game companies.
1094# 1385#
1095# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1386# If the file is not specified, then ${A} is used. If the
1096# - If the file is not specified then unpack will utilize ${A}.
1097# - If the offset is not specified then we will attempt to extract 1387# offset is not specified then we will attempt to extract
1098# the proper offset from the script itself. 1388# the proper offset from the script itself.
1099unpack_makeself() { 1389unpack_makeself() {
1100 local src_input=${1:-${A}} 1390 local src_input=${1:-${A}}
1101 local src=$(find_unpackable_file "${src_input}") 1391 local src=$(find_unpackable_file "${src_input}")
1102 local skip=$2 1392 local skip=$2
1103 local exe=$3 1393 local exe=$3
1105 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1395 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1106 1396
1107 local shrtsrc=$(basename "${src}") 1397 local shrtsrc=$(basename "${src}")
1108 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1398 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1109 if [[ -z ${skip} ]] ; then 1399 if [[ -z ${skip} ]] ; then
1110 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1400 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1111 local skip=0 1401 local skip=0
1112 exe=tail 1402 exe=tail
1113 case ${ver} in 1403 case ${ver} in
1114 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1404 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1115 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1405 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1117 2.0|2.0.1) 1407 2.0|2.0.1)
1118 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1408 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1119 ;; 1409 ;;
1120 2.1.1) 1410 2.1.1)
1121 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1411 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1122 let skip="skip + 1" 1412 (( skip++ ))
1123 ;; 1413 ;;
1124 2.1.2) 1414 2.1.2)
1125 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1415 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1126 let skip="skip + 1" 1416 (( skip++ ))
1127 ;; 1417 ;;
1128 2.1.3) 1418 2.1.3)
1129 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1419 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1130 let skip="skip + 1" 1420 (( skip++ ))
1131 ;; 1421 ;;
1132 2.1.4|2.1.5) 1422 2.1.4|2.1.5)
1133 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1423 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1134 skip=$(head -n ${skip} "${src}" | wc -c) 1424 skip=$(head -n ${skip} "${src}" | wc -c)
1135 exe="dd" 1425 exe="dd"
1144 esac 1434 esac
1145 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1435 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1146 fi 1436 fi
1147 case ${exe} in 1437 case ${exe} in
1148 tail) exe="tail -n +${skip} '${src}'";; 1438 tail) exe="tail -n +${skip} '${src}'";;
1149 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1439 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1150 *) die "makeself cant handle exe '${exe}'" 1440 *) die "makeself cant handle exe '${exe}'"
1151 esac 1441 esac
1152 1442
1153 # lets grab the first few bytes of the file to figure out what kind of archive it is 1443 # lets grab the first few bytes of the file to figure out what kind of archive it is
1154 local tmpfile="$(emktemp)" 1444 local filetype tmpfile=$(emktemp)
1155 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1445 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1156 local filetype="$(file -b "${tmpfile}")" 1446 filetype=$(file -b "${tmpfile}") || die
1157 case ${filetype} in 1447 case ${filetype} in
1158 *tar\ archive) 1448 *tar\ archive*)
1159 eval ${exe} | tar --no-same-owner -xf - 1449 eval ${exe} | tar --no-same-owner -xf -
1160 ;; 1450 ;;
1161 bzip2*) 1451 bzip2*)
1162 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1452 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1163 ;; 1453 ;;
1173 ;; 1463 ;;
1174 esac 1464 esac
1175 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1465 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1176} 1466}
1177 1467
1468# @FUNCTION: check_license
1469# @USAGE: [license]
1470# @DESCRIPTION:
1178# Display a license for user to accept. 1471# Display a license for user to accept. If no license is
1179#
1180# Usage: check_license [license]
1181# - If the file is not specified then ${LICENSE} is used. 1472# specified, then ${LICENSE} is used.
1182check_license() { 1473check_license() {
1183 local lic=$1 1474 local lic=$1
1184 if [ -z "${lic}" ] ; then 1475 if [ -z "${lic}" ] ; then
1185 lic="${PORTDIR}/licenses/${LICENSE}" 1476 lic="${PORTDIR}/licenses/${LICENSE}"
1186 else 1477 else
1190 lic="${PWD}/${lic}" 1481 lic="${PWD}/${lic}"
1191 elif [ -e "${lic}" ] ; then 1482 elif [ -e "${lic}" ] ; then
1192 lic="${lic}" 1483 lic="${lic}"
1193 fi 1484 fi
1194 fi 1485 fi
1195 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1196 local l="`basename ${lic}`" 1486 local l="`basename ${lic}`"
1197 1487
1198 # here is where we check for the licenses the user already 1488 # here is where we check for the licenses the user already
1199 # accepted ... if we don't find a match, we make the user accept 1489 # accepted ... if we don't find a match, we make the user accept
1200 local shopts=$-
1201 local alic 1490 local alic
1202 set -o noglob #so that bash doesn't expand "*" 1491 eshopts_push -o noglob # so that bash doesn't expand "*"
1203 for alic in ${ACCEPT_LICENSE} ; do 1492 for alic in ${ACCEPT_LICENSE} ; do
1204 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1493 if [[ ${alic} == ${l} ]]; then
1205 set +o noglob; set -${shopts} #reset old shell opts 1494 eshopts_pop
1206 return 0 1495 return 0
1207 fi 1496 fi
1208 done 1497 done
1209 set +o noglob; set -$shopts #reset old shell opts 1498 eshopts_pop
1499 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1210 1500
1211 local licmsg="$(emktemp)" 1501 local licmsg=$(emktemp)
1212 cat << EOF > ${licmsg} 1502 cat <<-EOF > ${licmsg}
1213********************************************************** 1503 **********************************************************
1214The following license outlines the terms of use of this 1504 The following license outlines the terms of use of this
1215package. You MUST accept this license for installation to 1505 package. You MUST accept this license for installation to
1216continue. When you are done viewing, hit 'q'. If you 1506 continue. When you are done viewing, hit 'q'. If you
1217CTRL+C out of this, the install will not run! 1507 CTRL+C out of this, the install will not run!
1218********************************************************** 1508 **********************************************************
1219 1509
1220EOF 1510 EOF
1221 cat ${lic} >> ${licmsg} 1511 cat ${lic} >> ${licmsg}
1222 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1512 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1223 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1513 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1224 read alic 1514 read alic
1225 case ${alic} in 1515 case ${alic} in
1232 die "Failed to accept license" 1522 die "Failed to accept license"
1233 ;; 1523 ;;
1234 esac 1524 esac
1235} 1525}
1236 1526
1527# @FUNCTION: cdrom_get_cds
1528# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1529# @DESCRIPTION:
1237# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1530# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1238# the whole 'non-interactive' policy, but damnit I want CD support ! 1531# the whole 'non-interactive' policy, but damnit I want CD support !
1239# 1532#
1240# with these cdrom functions we handle all the user interaction and 1533# With these cdrom functions we handle all the user interaction and
1241# standardize everything. all you have to do is call cdrom_get_cds() 1534# standardize everything. All you have to do is call cdrom_get_cds()
1242# and when the function returns, you can assume that the cd has been 1535# and when the function returns, you can assume that the cd has been
1243# found at CDROM_ROOT. 1536# found at CDROM_ROOT.
1244# 1537#
1538# The function will attempt to locate a cd based upon a file that is on
1539# the cd. The more files you give this function, the more cds
1540# the cdrom functions will handle.
1541#
1245# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1542# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1246# etc... if you want to give the cds better names, then just export 1543# etc... If you want to give the cds better names, then just export
1247# the appropriate CDROM_NAME variable before calling cdrom_get_cds(). 1544# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1248# - CDROM_NAME="fooie cd" - for when you only want 1 cd 1545# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1249# - CDROM_NAME_1="install cd" - for when you want more than 1 cd 1546# also use the CDROM_NAME_SET bash array.
1250# CDROM_NAME_2="data cd"
1251# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1252# 1547#
1253# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1548# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1254#
1255# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1256# - this will attempt to locate a cd based upon a file that is on
1257# the cd ... the more files you give this function, the more cds
1258# the cdrom functions will handle
1259cdrom_get_cds() { 1549cdrom_get_cds() {
1260 # first we figure out how many cds we're dealing with by 1550 # first we figure out how many cds we're dealing with by
1261 # the # of files they gave us 1551 # the # of files they gave us
1262 local cdcnt=0 1552 local cdcnt=0
1263 local f= 1553 local f=
1287 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1577 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1288 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1578 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1289 export CDROM_SET=-1 1579 export CDROM_SET=-1
1290 for f in ${CDROM_CHECK_1//:/ } ; do 1580 for f in ${CDROM_CHECK_1//:/ } ; do
1291 ((++CDROM_SET)) 1581 ((++CDROM_SET))
1292 [[ -e ${CD_ROOT}/${f} ]] && break 1582 [[ -e ${CDROM_ROOT}/${f} ]] && break
1293 done 1583 done
1294 export CDROM_MATCH=${f} 1584 export CDROM_MATCH=${f}
1295 return 1585 return
1296 fi 1586 fi
1297 1587
1349 export CDROM_SET="" 1639 export CDROM_SET=""
1350 export CDROM_CURRENT_CD=0 1640 export CDROM_CURRENT_CD=0
1351 cdrom_load_next_cd 1641 cdrom_load_next_cd
1352} 1642}
1353 1643
1354# this is only used when you need access to more than one cd. 1644# @FUNCTION: cdrom_load_next_cd
1355# when you have finished using the first cd, just call this function. 1645# @DESCRIPTION:
1356# when it returns, CDROM_ROOT will be pointing to the second cd. 1646# Some packages are so big they come on multiple CDs. When you're done reading
1357# remember, you can only go forward in the cd chain, you can't go back. 1647# files off a CD and want access to the next one, just call this function.
1648# Again, all the messy details of user interaction are taken care of for you.
1649# Once this returns, just read the variable CDROM_ROOT for the location of the
1650# mounted CD. Note that you can only go forward in the CD list, so make sure
1651# you only call this function when you're done using the current CD.
1358cdrom_load_next_cd() { 1652cdrom_load_next_cd() {
1359 local var 1653 local var
1360 ((++CDROM_CURRENT_CD)) 1654 ((++CDROM_CURRENT_CD))
1361 1655
1362 unset CDROM_ROOT 1656 unset CDROM_ROOT
1379# displayed and we'll hang out here until: 1673# displayed and we'll hang out here until:
1380# (1) the file is found on a mounted cdrom 1674# (1) the file is found on a mounted cdrom
1381# (2) the user hits CTRL+C 1675# (2) the user hits CTRL+C
1382_cdrom_locate_file_on_cd() { 1676_cdrom_locate_file_on_cd() {
1383 local mline="" 1677 local mline=""
1384 local showedmsg=0 1678 local showedmsg=0 showjolietmsg=0
1385 1679
1386 while [[ -z ${CDROM_ROOT} ]] ; do 1680 while [[ -z ${CDROM_ROOT} ]] ; do
1387 local i=0 1681 local i=0
1388 local -a cdset=(${*//:/ }) 1682 local -a cdset=(${*//:/ })
1389 if [[ -n ${CDROM_SET} ]] ; then 1683 if [[ -n ${CDROM_SET} ]] ; then
1392 1686
1393 while [[ -n ${cdset[${i}]} ]] ; do 1687 while [[ -n ${cdset[${i}]} ]] ; do
1394 local dir=$(dirname ${cdset[${i}]}) 1688 local dir=$(dirname ${cdset[${i}]})
1395 local file=$(basename ${cdset[${i}]}) 1689 local file=$(basename ${cdset[${i}]})
1396 1690
1397 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1691 local point= node= fs= foo=
1692 while read point node fs foo ; do
1693 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1694 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1695 && continue
1696 point=${point//\040/ }
1398 [[ -d ${mline}/${dir} ]] || continue 1697 [[ ! -d ${point}/${dir} ]] && continue
1399 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1698 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1400 export CDROM_ROOT=${mline} 1699 export CDROM_ROOT=${point}
1401 export CDROM_SET=${i} 1700 export CDROM_SET=${i}
1402 export CDROM_MATCH=${cdset[${i}]} 1701 export CDROM_MATCH=${cdset[${i}]}
1403 return 1702 return
1404 fi 1703 done <<< "$(get_mounts)"
1405 done
1406 1704
1407 ((++i)) 1705 ((++i))
1408 done 1706 done
1409 1707
1410 echo 1708 echo
1426 showedmsg=1 1724 showedmsg=1
1427 fi 1725 fi
1428 einfo "Press return to scan for the cd again" 1726 einfo "Press return to scan for the cd again"
1429 einfo "or hit CTRL+C to abort the emerge." 1727 einfo "or hit CTRL+C to abort the emerge."
1430 echo 1728 echo
1729 if [[ ${showjolietmsg} -eq 0 ]] ; then
1730 showjolietmsg=1
1731 else
1431 einfo "If you are having trouble with the detection" 1732 ewarn "If you are having trouble with the detection"
1432 einfo "of your CD, it is possible that you do not have" 1733 ewarn "of your CD, it is possible that you do not have"
1433 einfo "Joliet support enabled in your kernel. Please" 1734 ewarn "Joliet support enabled in your kernel. Please"
1434 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1735 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1736 ebeep 5
1737 fi
1435 read || die "something is screwed with your system" 1738 read || die "something is screwed with your system"
1436 done 1739 done
1437} 1740}
1438 1741
1742# @FUNCTION: strip-linguas
1743# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1744# @DESCRIPTION:
1439# Make sure that LINGUAS only contains languages that 1745# Make sure that LINGUAS only contains languages that
1440# a package can support 1746# a package can support. The first form allows you to
1441# 1747# specify a list of LINGUAS. The -i builds a list of po
1442# usage: strip-linguas <allow LINGUAS> 1748# files found in all the directories and uses the
1443# strip-linguas -i <directories of .po files> 1749# intersection of the lists. The -u builds a list of po
1444# strip-linguas -u <directories of .po files> 1750# files found in all the directories and uses the union
1445# 1751# of the lists.
1446# The first form allows you to specify a list of LINGUAS.
1447# The -i builds a list of po files found in all the
1448# directories and uses the intersection of the lists.
1449# The -u builds a list of po files found in all the
1450# directories and uses the union of the lists.
1451strip-linguas() { 1752strip-linguas() {
1452 local ls newls nols 1753 local ls newls nols
1453 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1754 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1454 local op=$1; shift 1755 local op=$1; shift
1455 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1756 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1456 local d f 1757 local d f
1457 for d in "$@" ; do 1758 for d in "$@" ; do
1458 if [[ ${op} == "-u" ]] ; then 1759 if [[ ${op} == "-u" ]] ; then
1459 newls=${ls} 1760 newls=${ls}
1460 else 1761 else
1461 newls="" 1762 newls=""
1462 fi 1763 fi
1463 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1764 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1464 if [[ ${op} == "-i" ]] ; then 1765 if [[ ${op} == "-i" ]] ; then
1465 hasq ${f} ${ls} && newls="${newls} ${f}" 1766 has ${f} ${ls} && newls="${newls} ${f}"
1466 else 1767 else
1467 hasq ${f} ${ls} || newls="${newls} ${f}" 1768 has ${f} ${ls} || newls="${newls} ${f}"
1468 fi 1769 fi
1469 done 1770 done
1470 ls=${newls} 1771 ls=${newls}
1471 done 1772 done
1472 else 1773 else
1474 fi 1775 fi
1475 1776
1476 nols="" 1777 nols=""
1477 newls="" 1778 newls=""
1478 for f in ${LINGUAS} ; do 1779 for f in ${LINGUAS} ; do
1479 if hasq ${f} ${ls} ; then 1780 if has ${f} ${ls} ; then
1480 newls="${newls} ${f}" 1781 newls="${newls} ${f}"
1481 else 1782 else
1482 nols="${nols} ${f}" 1783 nols="${nols} ${f}"
1483 fi 1784 fi
1484 done 1785 done
1485 [[ -n ${newls} ]] \ 1786 [[ -n ${nols} ]] \
1486 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1787 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1487 export LINGUAS=${newls:1} 1788 export LINGUAS=${newls:1}
1488} 1789}
1489 1790
1490# moved from kernel.eclass since they are generally useful outside of 1791# @FUNCTION: preserve_old_lib
1491# kernel.eclass -iggy (20041002) 1792# @USAGE: <libs to preserve> [more libs]
1492 1793# @DESCRIPTION:
1493# the following functions are useful in kernel module ebuilds, etc.
1494# for an example see ivtv or drbd ebuilds
1495
1496# set's ARCH to match what the kernel expects
1497set_arch_to_kernel() {
1498 i=10
1499 while ((i--)) ; do
1500 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1501 done
1502 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1503 case ${ARCH} in
1504 x86) export ARCH="i386";;
1505 amd64) export ARCH="x86_64";;
1506 hppa) export ARCH="parisc";;
1507 mips) export ARCH="mips";;
1508 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1509 *) export ARCH="${ARCH}";;
1510 esac
1511}
1512
1513# set's ARCH back to what portage expects
1514set_arch_to_portage() {
1515 i=10
1516 while ((i--)) ; do
1517 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1518 done
1519 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1520}
1521
1522# Jeremy Huddleston <eradicator@gentoo.org>:
1523# preserve_old_lib /path/to/libblah.so.0
1524# preserve_old_lib_notify /path/to/libblah.so.0
1525#
1526# These functions are useful when a lib in your package changes --library. Such 1794# These functions are useful when a lib in your package changes ABI SONAME.
1527# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1795# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1528# would break packages that link against it. Most people get around this 1796# would break packages that link against it. Most people get around this
1529# by using the portage SLOT mechanism, but that is not always a relevant 1797# by using the portage SLOT mechanism, but that is not always a relevant
1530# solution, so instead you can add the following to your ebuilds: 1798# solution, so instead you can call this from pkg_preinst. See also the
1531# 1799# preserve_old_lib_notify function.
1532# src_install() {
1533# ...
1534# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1535# ...
1536# }
1537#
1538# pkg_postinst() {
1539# ...
1540# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1541# ...
1542# }
1543
1544preserve_old_lib() { 1800preserve_old_lib() {
1545 LIB=$1 1801 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1802 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1803 die "Invalid preserve_old_lib() usage"
1804 fi
1805 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1546 1806
1547 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1807 # let portage worry about it
1548 SONAME=`basename ${LIB}` 1808 has preserve-libs ${FEATURES} && return 0
1549 DIRNAME=`dirname ${LIB}`
1550 1809
1551 dodir ${DIRNAME} 1810 local lib dir
1552 cp ${ROOT}${LIB} ${D}${DIRNAME} 1811 for lib in "$@" ; do
1812 [[ -e ${ROOT}/${lib} ]] || continue
1813 dir=${lib%/*}
1814 dodir ${dir} || die "dodir ${dir} failed"
1815 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1553 touch ${D}${LIB} 1816 touch "${D}"/${lib}
1554 fi 1817 done
1555} 1818}
1556 1819
1820# @FUNCTION: preserve_old_lib_notify
1821# @USAGE: <libs to notify> [more libs]
1822# @DESCRIPTION:
1823# Spit helpful messages about the libraries preserved by preserve_old_lib.
1557preserve_old_lib_notify() { 1824preserve_old_lib_notify() {
1558 LIB=$1 1825 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1826 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1827 die "Invalid preserve_old_lib_notify() usage"
1828 fi
1559 1829
1560 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1830 # let portage worry about it
1561 SONAME=`basename ${LIB}` 1831 has preserve-libs ${FEATURES} && return 0
1562 1832
1833 local lib notice=0
1834 for lib in "$@" ; do
1835 [[ -e ${ROOT}/${lib} ]] || continue
1836 if [[ ${notice} -eq 0 ]] ; then
1837 notice=1
1563 ewarn "An old version of an installed library was detected on your system." 1838 ewarn "Old versions of installed libraries were detected on your system."
1564 ewarn "In order to avoid breaking packages that link against it, this older version" 1839 ewarn "In order to avoid breaking packages that depend on these old libs,"
1565 ewarn "is not being removed. In order to make full use of this newer version," 1840 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1566 ewarn "you will need to execute the following command:" 1841 ewarn "in order to remove these old dependencies. If you do not have this"
1842 ewarn "helper program, simply emerge the 'gentoolkit' package."
1843 ewarn
1844 fi
1845 # temp hack for #348634 #357225
1846 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1567 ewarn " revdep-rebuild --library ${SONAME}" 1847 ewarn " # revdep-rebuild --library '${lib}'"
1848 done
1849 if [[ ${notice} -eq 1 ]] ; then
1568 ewarn 1850 ewarn
1569 ewarn "After doing that, you can safely remove ${LIB}" 1851 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1570 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1852 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1853 for lib in "$@" ; do
1854 ewarn " # rm '${lib}'"
1855 done
1571 fi 1856 fi
1572} 1857}
1573 1858
1574# Hack for people to figure out if a package was built with 1859# @FUNCTION: built_with_use
1575# certain USE flags 1860# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1861# @DESCRIPTION:
1576# 1862#
1577# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1863# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1578# ex: built_with_use xchat gtk2
1579# 1864#
1580# Flags: -a all USE flags should be utilized 1865# A temporary hack until portage properly supports DEPENDing on USE
1581# -o at least one USE flag should be utilized 1866# flags being enabled in packages. This will check to see if the specified
1582# Note: the default flag is '-a' 1867# DEPEND atom was built with the specified list of USE flags. The
1868# --missing option controls the behavior if called on a package that does
1869# not actually support the defined USE flags (aka listed in IUSE).
1870# The default is to abort (call die). The -a and -o flags control
1871# the requirements of the USE flags. They correspond to "and" and "or"
1872# logic. So the -a flag means all listed USE flags must be enabled
1873# while the -o flag means at least one of the listed IUSE flags must be
1874# enabled. The --hidden option is really for internal use only as it
1875# means the USE flag we're checking is hidden expanded, so it won't be found
1876# in IUSE like normal USE flags.
1877#
1878# Remember that this function isn't terribly intelligent so order of optional
1879# flags matter.
1583built_with_use() { 1880built_with_use() {
1881 local hidden="no"
1882 if [[ $1 == "--hidden" ]] ; then
1883 hidden="yes"
1884 shift
1885 fi
1886
1887 local missing_action="die"
1888 if [[ $1 == "--missing" ]] ; then
1889 missing_action=$2
1890 shift ; shift
1891 case ${missing_action} in
1892 true|false|die) ;;
1893 *) die "unknown action '${missing_action}'";;
1894 esac
1895 fi
1896
1584 local opt=$1 1897 local opt=$1
1585 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1898 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1586 1899
1587 local PKG=$(best_version $1) 1900 local PKG=$(best_version $1)
1901 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1588 shift 1902 shift
1589 1903
1590 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1904 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1905 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1591 1906
1592 # if the USE file doesnt exist, assume the $PKG is either 1907 # if the IUSE file doesn't exist, the read will error out, we need to handle
1593 # injected or package.provided 1908 # this gracefully
1594 [[ ! -e ${USEFILE} ]] && return 0 1909 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1910 case ${missing_action} in
1911 true) return 0;;
1912 false) return 1;;
1913 die) die "Unable to determine what USE flags $PKG was built with";;
1914 esac
1915 fi
1916
1917 if [[ ${hidden} == "no" ]] ; then
1918 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1919 # Don't check USE_EXPAND #147237
1920 local expand
1921 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1922 if [[ $1 == ${expand}_* ]] ; then
1923 expand=""
1924 break
1925 fi
1926 done
1927 if [[ -n ${expand} ]] ; then
1928 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1929 case ${missing_action} in
1930 true) return 0;;
1931 false) return 1;;
1932 die) die "$PKG does not actually support the $1 USE flag!";;
1933 esac
1934 fi
1935 fi
1936 fi
1595 1937
1596 local USE_BUILT=$(<${USEFILE}) 1938 local USE_BUILT=$(<${USEFILE})
1597 while [[ $# -gt 0 ]] ; do 1939 while [[ $# -gt 0 ]] ; do
1598 if [[ ${opt} = "-o" ]] ; then 1940 if [[ ${opt} = "-o" ]] ; then
1599 has $1 ${USE_BUILT} && return 0 1941 has $1 ${USE_BUILT} && return 0
1603 shift 1945 shift
1604 done 1946 done
1605 [[ ${opt} = "-a" ]] 1947 [[ ${opt} = "-a" ]]
1606} 1948}
1607 1949
1950# @FUNCTION: epunt_cxx
1951# @USAGE: [dir to scan]
1952# @DESCRIPTION:
1608# Many configure scripts wrongly bail when a C++ compiler 1953# Many configure scripts wrongly bail when a C++ compiler could not be
1609# could not be detected. #73450 1954# detected. If dir is not specified, then it defaults to ${S}.
1955#
1956# http://bugs.gentoo.org/73450
1610epunt_cxx() { 1957epunt_cxx() {
1611 local dir=$1 1958 local dir=$1
1612 [[ -z ${dir} ]] && dir=${S} 1959 [[ -z ${dir} ]] && dir=${S}
1613 ebegin "Removing useless C++ checks" 1960 ebegin "Removing useless C++ checks"
1614 local f 1961 local f
1615 for f in $(find ${dir} -name configure) ; do 1962 find "${dir}" -name configure | while read f ; do
1616 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1963 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1617 done 1964 done
1618 eend 0 1965 eend 0
1619} 1966}
1620 1967
1621# dopamd <file> [more files] 1968# @FUNCTION: make_wrapper
1622# 1969# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1623# Install pam auth config file in /etc/pam.d 1970# @DESCRIPTION:
1624dopamd() { 1971# Create a shell wrapper script named wrapper in installpath
1625 [[ -z $1 ]] && die "dopamd requires at least one argument" 1972# (defaults to the bindir) to execute target (default of wrapper) by
1626 1973# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1627 use pam || return 0 1974# libpaths followed by optionally changing directory to chdir.
1628
1629 INSDESTTREE=/etc/pam.d \
1630 doins "$@" || die "failed to install $@"
1631}
1632# newpamd <old name> <new name>
1633#
1634# Install pam file <old name> as <new name> in /etc/pam.d
1635newpamd() {
1636 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1637
1638 use pam || return 0
1639
1640 INSDESTTREE=/etc/pam.d \
1641 newins "$1" "$2" || die "failed to install $1 as $2"
1642}
1643
1644# make a wrapper script ...
1645# NOTE: this was originally games_make_wrapper, but I noticed other places where
1646# this could be used, so I have moved it here and made it not games-specific
1647# -- wolf31o2
1648# $1 == wrapper name
1649# $2 == binary to run
1650# $3 == directory to chdir before running binary
1651# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1652# $5 == path for wrapper
1653make_wrapper() { 1975make_wrapper() {
1654 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1976 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1655 local tmpwrapper=$(emktemp) 1977 local tmpwrapper=$(emktemp)
1656 # We don't want to quote ${bin} so that people can pass complex 1978 # We don't want to quote ${bin} so that people can pass complex
1657 # things as $bin ... "./someprog --args" 1979 # things as $bin ... "./someprog --args"
1667fi 1989fi
1668exec ${bin} "\$@" 1990exec ${bin} "\$@"
1669EOF 1991EOF
1670 chmod go+rx "${tmpwrapper}" 1992 chmod go+rx "${tmpwrapper}"
1671 if [[ -n ${path} ]] ; then 1993 if [[ -n ${path} ]] ; then
1994 (
1672 exeinto "${path}" 1995 exeinto "${path}"
1673 newexe "${tmpwrapper}" "${wrapper}" 1996 newexe "${tmpwrapper}" "${wrapper}"
1997 ) || die
1674 else 1998 else
1675 newbin "${tmpwrapper}" "${wrapper}" 1999 newbin "${tmpwrapper}" "${wrapper}" || die
1676 fi 2000 fi
1677} 2001}
2002
2003# @FUNCTION: path_exists
2004# @USAGE: [-a|-o] <paths>
2005# @DESCRIPTION:
2006# Check if the specified paths exist. Works for all types of paths
2007# (files/dirs/etc...). The -a and -o flags control the requirements
2008# of the paths. They correspond to "and" and "or" logic. So the -a
2009# flag means all the paths must exist while the -o flag means at least
2010# one of the paths must exist. The default behavior is "and". If no
2011# paths are specified, then the return value is "false".
2012path_exists() {
2013 local opt=$1
2014 [[ ${opt} == -[ao] ]] && shift || opt="-a"
2015
2016 # no paths -> return false
2017 # same behavior as: [[ -e "" ]]
2018 [[ $# -eq 0 ]] && return 1
2019
2020 local p r=0
2021 for p in "$@" ; do
2022 [[ -e ${p} ]]
2023 : $(( r += $? ))
2024 done
2025
2026 case ${opt} in
2027 -a) return $(( r != 0 )) ;;
2028 -o) return $(( r == $# )) ;;
2029 esac
2030}

Legend:
Removed from v.1.243  
changed lines
  Added in v.1.363

  ViewVC Help
Powered by ViewVC 1.1.20